Add new commands cluster [ destroy | update_hosts | boot ]
[tridge/autocluster.git] / autocluster
1 #!/bin/bash
2 # main autocluster script
3 #
4 # Copyright (C) Andrew Tridgell  2008
5 # Copyright (C) Martin Schwenke  2008
6 #
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 3 of the License, or
10 # (at your option) any later version.
11 #   
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #   
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, see <http://www.gnu.org/licenses/>.
19
20 ##BEGIN-INSTALLDIR-MAGIC##
21 # There are better ways of doing this but not if you still want to be
22 # able to run straight out of a git tree.  :-)
23 if [ -f "$0" ]; then
24     autocluster="$0"
25 else
26     autocluster=$(which "$0")
27 fi
28 if [ -L "$autocluster" ] ; then
29     autocluster=$(readlink "$autocluster")
30 fi
31 installdir=$(dirname "$autocluster")
32 ##END-INSTALLDIR-MAGIC##
33
34 ####################
35 # show program usage
36 usage ()
37 {
38     cat <<EOF
39 Usage: autocluster [OPTION] ... <COMMAND>
40   options:
41      -c <file>                   specify config file (default is "config")
42      -e <expr>                   execute <expr> and exit
43      -E <expr>                   execute <expr> and continue
44      -x                          enable script debugging
45      --dump                      dump config settings and exit
46
47   configuration options:
48 EOF
49
50     usage_config_options
51
52     cat <<EOF
53
54   commands:
55      base [ create | boot ] ...
56
57      cluster [ destroy | create | update_hosts | boot ] ...
58
59      create base
60            create a base image
61
62      create cluster [ CLUSTERNAME ]
63            create a full cluster
64
65      create node CLUSTERNAME IP_OFFSET
66            (re)create a single cluster node
67
68      mount DISK
69            mount a qemu disk on mnt/
70
71      unmount | umount
72            unmount a qemu disk from mnt/
73
74      bootbase
75            boot the base image
76 EOF
77     exit 1
78 }
79
80 ###############################
81
82 die () {
83     if [ "$no_sanity" = 1 ] ; then
84         fill_text 0 "WARNING: $*" >&2
85     else
86         fill_text 0 "ERROR: $*" >&2
87         exit 1
88     fi
89 }
90
91 announce ()
92 {
93     echo "######################################################################"
94     printf "# %-66s #\n" "$*"
95     echo "######################################################################"
96     echo ""
97 }
98
99 ###############################
100
101 # Indirectly call a function named by ${1}_${2}
102 call_func () {
103     local func="$1" ; shift
104     local type="$1" ; shift
105
106     local f="${func}_${type}"
107     if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null ; then
108         "$f" "$@"
109     else
110         f="${func}_DEFAULT"
111         if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null  ; then
112             "$f" "$type" "$@"
113         else
114             die "No function defined for \"${func}\" \"${type}\""
115         fi
116     fi
117 }
118
119 # Note that this will work if you pass "call_func f" because the first
120 # element of the node tuple is the node type.  Nice...  :-)
121 for_each_node ()
122 {
123     local n
124     for n in $NODES ; do
125         "$@" $(IFS=: ; echo $n)
126     done
127 }
128
129 hack_one_node_with ()
130 {
131     local filter="$1" ; shift
132
133     local node_type="$1"
134     local ip_offset="$2"
135     local name="$3"
136     local ctdb_node="$4"
137
138     $filter
139
140     local item="${node_type}:${ip_offset}${name:+:}${name}${ctdb_node:+:}${ctdb_node}"
141     nodes="${nodes}${nodes:+ }${item}"
142 }
143
144 # This also gets used for non-filtering iteration.
145 hack_all_nodes_with ()
146 {
147     local filter="$1"
148
149     local nodes=""
150     for_each_node hack_one_node_with "$filter"
151     NODES="$nodes"
152 }
153
154 register_hook ()
155 {
156     local hook_var="$1"
157     local new_hook="$2"
158
159     eval "$hook_var=\"${!hook_var}${!hook_var:+ }${new_hook}\""
160 }
161
162 run_hooks ()
163 {
164     local hook_var="$1"
165     shift
166
167     local i
168     for i in ${!hook_var} ; do
169         $i "$@"
170     done
171 }
172
173 # Use with care, since this may clear some autocluster defaults.!
174 clear_hooks ()
175 {
176     local hook_var="$1"
177
178     eval "$hook_var=\"\""
179 }
180
181 ##############################
182
183 # These hooks are intended to customise the value of $DISK.  They have
184 # access to 1 argument ("base", "system", "shared") and the variables
185 # $VIRTBASE, $CLUSTER, $BASENAME (for "base"), $NAME (for "system"),
186 # $SHARED_DISK_NUM (for "shared").  A hook must be deterministic and
187 # should not be stateful, since they can be called multiple times for
188 # the same disk.
189 hack_disk_hooks=""
190
191 # common node creation stuff
192 create_node_COMMON ()
193 {
194     local NAME="$1"
195     local ip_offset="$2"
196     local type="$3"
197     local template_file="${4:-$NODE_TEMPLATE}"
198
199     if [ "$SYSTEM_DISK_FORMAT" != "qcow2" -a "$BASE_FORMAT" = "qcow2" ] ; then
200         die "Error: if BASE_FORMAT is \"qcow2\" then SYSTEM_DISK_FORMAT must also be \"qcow2\"."
201     fi
202
203     local IPNUM=$(($FIRSTIP + $ip_offset))
204     make_network_map
205
206     # Determine base image name.  We use $DISK temporarily to allow
207     # the path to be hacked.
208     local DISK="${VIRTBASE}/${BASENAME}.${BASE_FORMAT}"
209     if [ "$BASE_PER_NODE_TYPE" = "yes" ] ; then
210         DISK="${VIRTBASE}/${BASENAME}-${type}.${BASE_FORMAT}"
211     fi
212     run_hooks hack_disk_hooks "base"
213     local base_disk="$DISK"
214
215     # Determine the system disk image name.
216     DISK="${VIRTBASE}/${CLUSTER}/${NAME}.${SYSTEM_DISK_FORMAT}"
217     run_hooks hack_disk_hooks "system"
218
219     local di="$DISK"
220     if [ "$DISK_FOLLOW_SYMLINKS" = "yes" -a -L "$DISK" ] ; then
221         di=$(readlink "$DISK")
222     fi
223     rm -f "$di"
224     local di_dirname="${di%/*}"
225     mkdir -p "$di_dirname"
226
227     case "$SYSTEM_DISK_FORMAT" in
228         qcow2)
229             echo "Creating the disk..."
230             qemu-img create -b "$base_disk" -f qcow2 "$di"
231             create_node_configure_image "$DISK" "$type"
232             ;;
233         raw)
234             echo "Creating the disk..."
235             cp -v --sparse=always "$base_disk" "$di"
236             create_node_configure_image "$DISK" "$type"
237             ;;
238         reflink)
239             echo "Creating the disk..."
240             cp -v --reflink=always "$base_disk" "$di"
241             create_node_configure_image "$DISK" "$type"
242             ;;
243         mmclone)
244             echo "Creating the disk (using mmclone)..."
245             local base_snap="${base_disk}.snap"
246             [ -f "$base_snap" ] || mmclone snap "$base_disk" "$base_snap"
247             mmclone copy "$base_snap" "$di"
248             create_node_configure_image "$DISK" "$type"
249             ;;
250         none)
251             echo "Skipping disk image creation as requested"
252             ;;
253         *)
254             die "Error: unknown SYSTEM_DISK_FORMAT=\"${SYSTEM_DISK_FORMAT}\"."
255     esac
256
257     # Pull the UUID for this node out of the map.
258     UUID=$(awk "\$1 == $ip_offset {print \$2}" $uuid_map)
259     
260     mkdir -p tmp
261
262     echo "Creating $NAME.xml"
263     substitute_vars $template_file tmp/$NAME.xml
264     
265     # install the XML file
266     $VIRSH undefine $NAME > /dev/null 2>&1 || true
267     $VIRSH define tmp/$NAME.xml
268 }
269
270 create_node_configure_image ()
271 {
272     local disk="$1"
273     local type="$2"
274
275     diskimage mount "$disk"
276     setup_base "$type"
277     diskimage unmount
278 }
279
280 # Provides an easy way of removing nodes from $NODE.
281 create_node_null () {
282     :
283 }
284
285 hack_network_map_hooks=""
286
287 # Uses: CLUSTER, NAME, NETWORKS, FIRSTIP, ip_offset
288 make_network_map ()
289 {
290     network_map="tmp/network_map.$NAME"
291
292     if [ -n "$CLUSTER" ] ; then
293         local md5=$(echo "$CLUSTER" | md5sum)
294         local nh=$(printf "%02x" $ip_offset)
295         local mac_prefix="02:${md5:0:2}:${md5:2:2}:00:${nh}:"
296     else
297         local mac_prefix="02:42:42:00:00:"
298     fi
299
300     local n
301     local count=1
302     for n in $NETWORKS ; do
303         local ch=$(printf "%02x" $count)
304         local mac="${mac_prefix}${ch}"
305
306         set -- ${n//,/ }
307         local ip_bits="$1" ; shift
308         local dev="$1" ; shift
309         local opts="$*"
310
311         local net="${ip_bits%/*}"
312         local netname="acnet_${net//./_}"
313
314         local ip="${net%.*}.${IPNUM}"
315         local mask="255.255.255.0"
316
317         # This can be used to override the variables in the echo
318         # statement below.  The hook can use any other variables
319         # available in this function.
320         run_hooks hack_network_map_hooks
321
322         echo "${netname} ${dev} ${ip} ${mask} ${mac} ${opts}"
323         count=$(($count + 1))
324     done >"$network_map"
325 }
326
327 ##############################
328
329 hack_nodes_functions=
330
331 expand_nodes () {
332     # Expand out any abbreviations in NODES.
333     local ns=""
334     local n
335     for n in $NODES ; do
336         local t="${n%:*}"
337         local ips="${n#*:}"
338         case "$ips" in
339             *,*)
340                 local i
341                 for i in ${ips//,/ } ; do
342                     ns="${ns}${ns:+ }${t}:${i}"
343                 done
344                 ;;
345             *-*)
346                 local i
347                 for i in $(seq ${ips/-/ }) ; do
348                     ns="${ns}${ns:+ }${t}:${i}"
349                 done
350                 ;;
351             *)
352                 ns="${ns}${ns:+ }${n}"
353         esac
354     done
355     NODES="$ns"
356
357     # Apply nodes hacks.  Some of this is about backward compatibility
358     # but the hacks also fill in the node names and whether they're
359     # part of the CTDB cluster.  The order is the order that
360     # configuration modules register their hacks.
361     run_hooks hack_nodes_functions
362
363     if [ -n "$NUMNODES" ] ; then
364         # Attempt to respect NUMNODES.  Reduce the number of CTDB
365         # nodes to NUMNODES.
366         local numnodes=$NUMNODES
367
368         hack_filter ()
369         {
370             if [ "$ctdb_node" = 1 ] ; then
371                 if [ $numnodes -gt 0 ] ; then
372                     numnodes=$(($numnodes - 1))
373                 else
374                     node_type="null"
375                     ctdb_node=0
376                 fi
377             fi
378         }
379
380         hack_all_nodes_with hack_filter
381                         
382         [ $numnodes -gt 0 ] && \
383             die "Can't not use NUMNODES to increase the number of nodes over that specified by NODES.  You need to set NODES instead - please read the documentation."
384     fi
385     
386     # Check IP addresses for duplicates.
387     local ip_offsets=":"
388     # This function doesn't modify anything...
389     get_ip_offset ()
390     {
391         [ "${ip_offsets/${ip_offset}}" != "$ip_offsets" ] && \
392             die "Duplicate IP offset in NODES - ${node_type}:${ip_offset}"
393         ip_offsets="${ip_offsets}${ip_offset}:"
394     }
395     hack_all_nodes_with get_ip_offset
396 }
397
398 ##############################
399
400 sanity_check_cluster_name ()
401 {
402     [ -z "${CLUSTER//[A-Za-z0-9]}" ] || \
403         die "Cluster names should be restricted to the characters A-Za-z0-9.  \
404 Some cluster filesystems have problems with other characters."
405 }
406
407 hosts_file=
408
409 common_nodelist_hacking ()
410 {
411     # Rework the NODES list
412     expand_nodes
413
414     # Build /etc/hosts and hack the names of the ctdb nodes
415     hosts_line_hack_name ()
416     {
417         # Ignore nodes without names (e.g. "null")
418         [ "$node_type" != "null" -a -n "$name" ] || return 0
419
420         local sname=""
421         local hosts_line
422         local ip_addr="${NETWORK_PRIVATE_PREFIX}.$(($FIRSTIP + $ip_offset))"
423         
424         if [ "$ctdb_node" = 1 ] ; then
425             num_ctdb_nodes=$(($num_ctdb_nodes + 1))
426             sname="${CLUSTER}n${num_ctdb_nodes}"
427             hosts_line="$ip_addr ${sname}.${ld} ${name}.${ld} $name $sname"
428             name="$sname"
429         else
430             hosts_line="$ip_addr ${name}.${ld} $name"
431         fi
432
433         # This allows you to add a function to your configuration file
434         # to modify hostnames (and other aspects of nodes).  This
435         # function can access/modify $name (the existing name),
436         # $node_type and $ctdb_node (1, if the node is a member of the
437         # CTDB cluster, 0 otherwise).
438         if [ -n "$HOSTNAME_HACKING_FUNCTION" ] ; then
439             local old_name="$name"
440             $HOSTNAME_HACKING_FUNCTION
441             if [ "$name" != "$old_name" ] ; then
442                 hosts_line="$ip_addr ${name}.${ld} $name"
443             fi
444         fi
445
446         echo "$hosts_line"
447     }
448     hosts_file="tmp/hosts.$CLUSTER"
449     {
450         local num_ctdb_nodes=0
451         local ld=$(echo $DOMAIN | tr A-Z a-z)
452         echo "# autocluster $CLUSTER"
453         hack_all_nodes_with hosts_line_hack_name
454         echo
455     } >$hosts_file
456
457     # Build /etc/ctdb/nodes
458     ctdb_nodes_line ()
459     {
460         [ "$ctdb_node" = 1 ] || return 0
461         echo "${NETWORK_PRIVATE_PREFIX}.$(($FIRSTIP + $ip_offset))"
462         num_nodes=$(($num_nodes + 1))
463     }
464     nodes_file="tmp/nodes.$CLUSTER"
465     local num_nodes=0
466     hack_all_nodes_with ctdb_nodes_line >$nodes_file
467     : "${NUMNODES:=${num_nodes}}"  # Set $NUMNODES if necessary
468
469     # Build UUID map
470     uuid_map="tmp/uuid_map.$CLUSTER"
471     uuid_map_line ()
472     {
473         echo "${ip_offset} $(uuidgen) ${node_type}"
474     }
475     hack_all_nodes_with uuid_map_line >$uuid_map
476 }
477
478 create_cluster_hooks=
479 cluster_created_hooks=
480
481 cluster_create ()
482 {
483     # Use $1.  If not set then use value from configuration file.
484     CLUSTER="${1:-${CLUSTER}}"
485     announce "cluster create \"${CLUSTER}\""
486     [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
487
488     sanity_check_cluster_name
489
490     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
491
492     # Run hooks before doing anything else.
493     run_hooks create_cluster_hooks
494
495     common_nodelist_hacking
496
497     for_each_node call_func create_node
498
499     echo "Cluster $CLUSTER created"
500     echo ""
501
502     run_hooks cluster_created_hooks
503 }
504
505 cluster_created_hosts_message ()
506 {
507     echo "You may want to add this to your /etc/hosts file:"
508     cat $hosts_file
509 }
510
511 register_hook cluster_created_hooks cluster_created_hosts_message
512
513 cluster_destroy ()
514 {
515     announce "cluster destroy \"${CLUSTER}\""
516     [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
517
518     vircmd destroy "$CLUSTER" || true
519 }
520
521 cluster_update_hosts ()
522 {
523     announce "cluster update_hosts \"${CLUSTER}\""
524     [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
525
526     [ -n "$hosts_file" ] || hosts_file="tmp/hosts.${CLUSTER}"
527     [ -r "$hosts_file" ] || die "Missing hosts file \"${hosts_file}\""
528
529     local pat="# autocluster ${CLUSTER}\$|[[:space:]]${CLUSTER}(n|base)[[:digit:]]+"
530
531     local t="/etc/hosts.${CLUSTER}"
532     grep -E "$pat" /etc/hosts >"$t" || true
533     if diff -B "$t" "$hosts_file" >/dev/null ; then
534         rm "$t"
535         return
536     fi
537
538     local old=/etc/hosts.old.autocluster
539     cp /etc/hosts "$old"
540     local new=/etc/hosts.new
541     grep -Ev "$pat" "$old" |
542     cat -s - "$hosts_file" >"$new"
543
544     mv "$new" /etc/hosts
545
546     echo "Made these changes to /etc/hosts:"
547     diff -u "$old" /etc/hosts || true
548 }
549
550 cluster_boot ()
551 {
552     [ -n "$CLUSTER_PATTERN" ] || CLUSTER_PATTERN="$CLUSTER"
553     announce "cluster boot \"${CLUSTER_PATTERN}\""
554     [ -n "$CLUSTER_PATTERN" ] || die "\$CLUSTER_PATTERN not set"
555
556     vircmd start "$CLUSTER_PATTERN"
557
558     local nodes=$(vircmd dominfo "$CLUSTER_PATTERN" 2>/dev/null | \
559         sed -n -e 's/Name: *//p')
560
561     # Wait for each node
562     local i
563     for i in $nodes ; do
564         waitfor "${KVMLOG}/serial.$i" "login:" 300 || {
565             vircmd destroy "$CLUSTER_PATTERN"
566             die "Failed to create cluster"
567         }
568     done
569
570     # Move past the last line of log output
571     echo ""
572 }
573
574 create_one_node ()
575 {
576     CLUSTER="$1"
577     local single_node_ip_offset="$2"
578
579     sanity_check_cluster_name
580
581     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
582
583     common_nodelist_hacking
584
585     for n in $NODES ; do
586         set -- $(IFS=: ; echo $n)
587         [ $single_node_ip_offset -eq $2 ] || continue
588         call_func create_node "$@"
589         
590         echo "Requested node created"
591         echo ""
592         echo "You may want to update your /etc/hosts file:"
593         cat $hosts_file
594         
595         break
596     done
597 }
598
599 ###############################
600 # test the proxy setup
601 test_proxy() {
602     export http_proxy=$WEBPROXY
603     wget -O /dev/null $INSTALL_SERVER || \
604         die "Your WEBPROXY setting \"$WEBPROXY\" is not working"
605     echo "Proxy OK"
606 }
607
608 ###################
609
610 kickstart_floppy_create_hooks=
611
612 guess_install_network ()
613 {
614     # Figure out IP address to use during base install.  Default to
615     # the IP address of the 1st (private) network. If a gateway is
616     # specified then use the IP address associated with it.
617     INSTALL_IP=""
618     INSTALL_GW=""
619     local netname dev ip mask mac opts
620     while read netname dev ip mask mac opts; do
621         local o
622         for o in $opts ; do
623             case "$o" in
624                 gw\=*)
625                     INSTALL_GW="${o#gw=}"
626                     INSTALL_IP="${ip}${FIRSTIP}"
627             esac
628         done
629         [ -n "$INSTALL_IP" ] || INSTALL_IP="$ip"
630     done <"$network_map"
631 }
632
633 # create base image
634 base_create()
635 {
636     local NAME="$BASENAME"
637     local DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
638     run_hooks hack_disk_hooks "base"
639
640     mkdir -p $KVMLOG
641
642     echo "Testing WEBPROXY $WEBPROXY"
643     test_proxy
644
645     local di="$DISK"
646     if [ "$DISK_FOLLOW_SYMLINKS" = "yes" -a -L "$DISK" ] ; then
647         di=$(readlink "$DISK")
648     fi
649     rm -f "$di"
650     local di_dirname="${di%/*}"
651     mkdir -p "$di_dirname"
652
653     echo "Creating the disk"
654     qemu-img create -f $BASE_FORMAT "$di" $DISKSIZE
655
656     rm -rf tmp
657     mkdir -p mnt tmp tmp/ISO
658
659     setup_timezone
660
661     make_network_map
662
663     guess_install_network
664
665     echo "Creating kickstart file from template"
666     substitute_vars "$KICKSTART" "tmp/ks.cfg"
667
668     # $ISO gets $ISO_DIR prepended if it doesn't start with a leading '/'.
669     case "$ISO" in
670         (/*) : ;;
671         (*) ISO="${ISO_DIR}/${ISO}"
672     esac
673     
674     echo "Creating kickstart floppy"
675     dd if=/dev/zero of=tmp/floppy.img bs=1024 count=1440
676     mkdosfs -n KICKSTART tmp/floppy.img
677     mount -o loop -t msdos tmp/floppy.img mnt
678     cp tmp/ks.cfg mnt
679     mount -o loop,ro $ISO tmp/ISO
680     
681     echo "Setting up bootloader"
682     cp tmp/ISO/isolinux/isolinux.bin tmp
683     cp tmp/ISO/isolinux/vmlinuz tmp
684     cp tmp/ISO/isolinux/initrd.img tmp
685
686     run_hooks kickstart_floppy_create_hooks
687
688     umount tmp/ISO
689     umount mnt
690
691     UUID=`uuidgen`
692
693     substitute_vars $INSTALL_TEMPLATE tmp/$NAME.xml
694
695     rm -f $KVMLOG/serial.$NAME
696
697     # boot the install CD
698     $VIRSH create tmp/$NAME.xml
699
700     echo "Waiting for install to start"
701     sleep 2
702     
703     # wait for the install to finish
704     if ! waitfor $KVMLOG/serial.$NAME "$KS_DONE_MESSAGE" $CREATE_BASE_TIMEOUT ; then
705         $VIRSH destroy $NAME
706         die "Failed to create base image ${DISK} after waiting for ${CREATE_BASE_TIMEOUT} seconds.
707 You may need to increase the value of CREATE_BASE_TIMEOUT.
708 Alternatively, the install might have completed but KS_DONE_MESSAGE
709 (currently \"${KS_DONE_MESSAGE}\")
710 may not have matched anything at the end of the kickstart output."
711     fi
712     
713     $VIRSH destroy $NAME
714
715     ls -l $DISK
716     cat <<EOF
717
718 Install finished, base image $DISK created
719
720 You may wish to run
721    chcon -t virt_content_t $DISK
722    chattr +i $DISK
723 To ensure that this image does not change
724
725 Note that the root password has been set to $ROOTPASSWORD
726
727 EOF
728 }
729
730 ###############################
731 # boot the base disk
732 base_boot() {
733     rm -rf tmp
734     mkdir -p tmp
735
736     NAME="$BASENAME"
737     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
738
739     IPNUM=$FIRSTIP
740
741     make_network_map
742
743     CLUSTER="base"
744
745     diskimage mount $DISK
746     setup_base
747     diskimage unmount
748
749     UUID=`uuidgen`
750     
751     echo "Creating $NAME.xml"
752     substitute_vars $BOOT_TEMPLATE tmp/$NAME.xml
753     
754     # boot the base system
755     $VIRSH create tmp/$NAME.xml
756 }
757
758 ######################################################################
759
760 # Updating a disk image...
761
762 diskimage ()
763 {
764     local func="$1"
765     shift
766     call_func diskimage_"$func" "$SYSTEM_DISK_ACCESS_METHOD" "$@"
767 }
768
769 # setup the files from $BASE_TEMPLATES/, substituting any variables
770 # based on the config
771 copy_base_dir_substitute_templates ()
772 {
773     local dir="$1"
774
775     local d="$BASE_TEMPLATES/$dir"
776     [ -d "$d" ] || return 0
777
778     local f
779     for f in $(cd "$d" && find . \! -name '*~' \( -type d -name .svn -prune -o -print \) ) ; do
780         f="${f#./}" # remove leading "./" for clarity
781         if [ -d "$d/$f" ]; then
782             # Don't chmod existing directory
783             if diskimage is_directory "/$f" ; then
784                 continue
785             fi
786             diskimage mkdir_p "/$f"
787         else
788             echo " Install: $f"
789             diskimage substitute_vars "$d/$f" "/$f"
790         fi
791         diskimage chmod_reference "$d/$f" "/$f"
792     done
793 }
794
795 setup_base_hooks=
796
797 setup_base_ssh_keys ()
798 {
799     # this is needed as git doesn't store file permissions other
800     # than execute
801     # Note that we protect the wildcards from the local shell.
802     diskimage chmod 600 "/etc/ssh/*key" "/root/.ssh/*"
803     diskimage chmod 700 "/etc/ssh" "/root/.ssh" "/root"
804     if [ -r "$HOME/.ssh/id_rsa.pub" ]; then
805        echo "Adding $HOME/.ssh/id_rsa.pub to ssh authorized_keys"
806        diskimage append_text_file "$HOME/.ssh/id_rsa.pub" "/root/.ssh/authorized_keys"
807     fi
808     if [ -r "$HOME/.ssh/id_dsa.pub" ]; then
809        echo "Adding $HOME/.ssh/id_dsa.pub to ssh authorized_keys"
810        diskimage append_text_file "$HOME/.ssh/id_dsa.pub" "/root/.ssh/authorized_keys"
811     fi
812 }
813
814 register_hook setup_base_hooks setup_base_ssh_keys
815
816 setup_base_grub_conf ()
817 {
818     echo "Adjusting grub.conf"
819     local o="$EXTRA_KERNEL_OPTIONS" # For readability.
820     local grub_configs="/boot/grub/grub.conf"
821     if ! diskimage is_file "$grub_configs" ; then
822         grub_configs="/etc/default/grub /boot/grub2/grub.cfg"
823     fi
824     local c
825     for c in $grub_configs ; do
826         diskimage sed "$c" \
827             -e "s/console=ttyS0,19200/console=ttyS0,115200/"  \
828             -e "s/ console=tty1//" -e "s/ rhgb/ norhgb/"  \
829             -e "s/ nodmraid//" -e "s/ nompath//"  \
830             -e "s/quiet/noapic divider=10${o:+ }${o}/g"
831     done
832 }
833
834 register_hook setup_base_hooks setup_base_grub_conf
835
836 setup_base()
837 {
838     local type="$1"
839
840     umask 022
841     echo "Copy base files"
842     copy_base_dir_substitute_templates "all"
843     if [ -n "$type" ] ; then
844         copy_base_dir_substitute_templates "$type"
845     fi
846
847     run_hooks setup_base_hooks
848 }
849
850 # setup various networking components
851 setup_network()
852 {
853     # This avoids doing anything when we're called from boot_base().
854     if [ -z "$hosts_file" ] ; then
855         echo "Skipping network-related setup"
856         return
857     fi
858
859     echo "Setting up networks"
860     diskimage append_text_file "$hosts_file" "/etc/hosts"
861
862     echo "Setting up /etc/ctdb/nodes"
863     diskimage mkdir_p "/etc/ctdb"
864     diskimage put "$nodes_file" "/etc/ctdb/nodes"
865
866     [ "$WEBPROXY" = "" ] || {
867         diskimage append_text "export http_proxy=$WEBPROXY" "/etc/bashrc"
868     }
869
870     if [ -n "$NFSSHARE" -a -n "$NFS_MOUNTPOINT" ] ; then
871         echo "Enabling nfs mount of $NFSSHARE"
872         diskimage mkdir_p "$NFS_MOUNTPOINT"
873         diskimage append_text "$NFSSHARE $NFS_MOUNTPOINT nfs nfsvers=3,intr 0 0" "/etc/fstab"
874     fi
875
876     diskimage mkdir_p "/etc/yum.repos.d"
877     echo '@@@YUM_TEMPLATE@@@' | diskimage substitute_vars - "/etc/yum.repos.d/autocluster.repo"
878
879     diskimage rm_rf "/etc/udev/rules.d/70-persistent-net.rules"
880
881     echo "Setting up network interfaces: "
882     local netname dev ip mask mac opts
883     while read netname dev ip mask mac opts; do
884         echo "  $dev"
885
886         local o gw
887         gw=""
888         for o in $opts ; do
889             case "$o" in
890                 gw\=*)
891                     gw="${o#gw=}"
892             esac
893         done
894
895         cat <<EOF | \
896             diskimage put - "/etc/sysconfig/network-scripts/ifcfg-${dev}"
897 DEVICE=$dev
898 ONBOOT=yes
899 TYPE=Ethernet
900 IPADDR=$ip
901 NETMASK=$mask
902 HWADDR=$mac
903 ${gw:+GATEWAY=}${gw}
904 EOF
905
906         # This goes to 70-persistent-net.rules
907         cat <<EOF
908 # Generated by autocluster
909 SUBSYSTEM=="net", ACTION=="add", DRIVERS=="?*", ATTR{address}=="${mac}", ATTR{type}=="1", KERNEL=="eth*", NAME="${dev}"
910
911 EOF
912     done <"$network_map" |
913     diskimage put - "/etc/udev/rules.d/70-persistent-net.rules"
914 }
915
916 register_hook setup_base_hooks setup_network
917
918 setup_timezone() {
919     [ -z "$TIMEZONE" ] && {
920         [ -r /etc/timezone ] && {
921             TIMEZONE=`cat /etc/timezone`
922         }
923         [ -r /etc/sysconfig/clock ] && {
924             . /etc/sysconfig/clock
925             TIMEZONE="$ZONE"
926         }
927         TIMEZONE="${TIMEZONE// /_}"
928     }
929     [ -n "$TIMEZONE" ] || \
930         die "Unable to determine TIMEZONE - please set in config"
931 }
932
933 # substite a set of variables of the form @@XX@@ for the shell
934 # variables $XX in a file.
935 #
936 # Indirect variables @@@XX@@@ (3 ats) specify that the variable should
937 # contain a filename whose contents are substituted, with variable
938 # substitution applied to those contents.  If filename starts with '|'
939 # it is a command instead - however, quoting is extremely fragile.
940 substitute_vars() {(
941         infile="${1:-/dev/null}" # if empty then default to /dev/null
942         outfile="$2" # optional
943
944         tmp_out=$(mktemp)
945         cat "$infile" >"$tmp_out"
946
947         # Handle any indirects by looping until nothing changes.
948         # However, only handle 10 levels of recursion.
949         count=0
950         while : ; do
951             if ! _substitute_vars "$tmp_out" "@@@" ; then
952                 rm -f "$tmp_out"
953                 die "Failed to expand template $infile"
954             fi
955
956             # No old version of file means no changes made.
957             if [ ! -f "${tmp_out}.old" ] ; then
958                 break
959             fi
960
961             rm -f "${tmp_out}.old"
962
963             count=$(($count + 1))
964             if [ $count -ge 10 ] ; then
965                 rm -f "$tmp_out"
966                 die "Recursion too deep in $infile - only 10 levels allowed!"
967             fi
968         done
969
970         # Now regular variables.
971         if ! _substitute_vars "$tmp_out" "@@" ; then
972             rm -f "$tmp_out"
973             die "Failed to expand template $infile"
974         fi
975         rm -f "${tmp_out}.old"
976
977         if [ -n "$outfile" ] ; then
978             mv "$tmp_out" "$outfile"
979         else
980             cat "$tmp_out"
981             rm -f "$tmp_out"
982         fi
983 )}
984
985
986 # Delimiter @@ means to substitute contents of variable.
987 # Delimiter @@@ means to substitute contents of file named by variable.
988 # @@@ supports leading '|' in variable value, which means to excute a
989 # command.
990 _substitute_vars() {(
991         tmp_out="$1"
992         delimiter="${2:-@@}"
993
994         # Get the list of variables used in the template.  The grep
995         # gets rid of any blank lines and lines with extraneous '@'s
996         # next to template substitutions.
997         VARS=$(sed -n -e "s#[^@]*${delimiter}\([A-Z0-9_][A-Z0-9_]*\)${delimiter}[^@]*#\1\n#gp" "$tmp_out" |
998             grep '^[A-Z0-9_][A-Z0-9_]*$' |
999             sort -u)
1000
1001         tmp=$(mktemp)
1002         for v in $VARS; do
1003             # variable variables are fun .....
1004             [ "${!v+x}" ] || {
1005                 rm -f $tmp
1006                 die "No substitution given for ${delimiter}$v${delimiter} in $infile"
1007             }
1008             s=${!v}
1009
1010             if [ "$delimiter" = "@@@" ] ; then
1011                 f=${s:-/dev/null}
1012                 c="${f#|}" # Is is a command, signified by a leading '|'?
1013                 if [ "$c" = "$f" ] ; then
1014                     # No leading '|', cat file.
1015                     s=$(cat -- "$f")
1016                     [ $? -eq 0 ] || {
1017                         rm -f $tmp
1018                         die "Could not substitute contents of file $f"
1019                     }
1020                 else
1021                     # Leading '|', execute command.
1022                     # Quoting problems here - using eval "$c" doesn't help.
1023                     s=$($c)
1024                     [ $? -eq 0 ] || {
1025                         rm -f $tmp
1026                         die "Could not execute command $c"
1027                     }
1028                 fi
1029             fi
1030
1031             # escape some pesky chars
1032             # This first one can be too slow if done using a bash
1033             # variable pattern subsitution.
1034             s=$(echo -n "$s" | tr '\n' '\001' | sed -e 's/\o001/\\n/g')
1035             s=${s//#/\\#}
1036             s=${s//&/\\&}
1037             echo "s#${delimiter}${v}${delimiter}#${s}#g"
1038         done > $tmp
1039
1040         # Get the in-place sed to make a backup of the old file.
1041         # Remove the backup if it is the same as the resulting file -
1042         # this acts as a flag to the caller that no changes were made.
1043         sed -i.old -f $tmp "$tmp_out"
1044         if cmp -s "${tmp_out}.old" "$tmp_out" ; then
1045             rm -f "${tmp_out}.old"
1046         fi
1047
1048         rm -f $tmp
1049 )}
1050
1051 check_command() {
1052     which $1 > /dev/null || die "Please install $1 to continue"
1053 }
1054
1055 # Set a variable if it isn't already set.  This allows environment
1056 # variables to override default config settings.
1057 defconf() {
1058     local v="$1"
1059     local e="$2"
1060
1061     [ "${!v+x}" ] || eval "$v=\"$e\""
1062 }
1063
1064 load_config () {
1065     local i
1066
1067     for i in "${installdir}/config.d/"*.defconf ; do
1068         . "$i"
1069     done
1070 }
1071
1072 # Print the list of config variables defined in config.d/.
1073 get_config_options () {( # sub-shell for local declaration of defconf()
1074         local options=
1075         defconf() { options="$options $1" ; }
1076         load_config
1077         echo $options
1078 )}
1079
1080 # Produce a list of long options, suitable for use with getopt, that
1081 # represent the config variables defined in config.d/.
1082 getopt_config_options () {
1083     local x=$(get_config_options | tr 'A-Z_' 'a-z-')
1084     echo "${x// /:,}:"
1085 }
1086
1087 # Unconditionally set the config variable associated with the given
1088 # long option.
1089 setconf_longopt () {
1090     local longopt="$1"
1091     local e="$2"
1092
1093     local v=$(echo "${longopt#--}" | tr 'a-z-' 'A-Z_')
1094     # unset so defconf will set it
1095     eval "unset $v"
1096     defconf "$v" "$e"
1097 }
1098
1099 # Dump all of the current config variables.
1100 dump_config() {
1101     local o
1102     for o in $(get_config_options) ; do
1103         echo "${o}=\"${!o}\""
1104     done
1105     exit 0
1106 }
1107
1108 # $COLUMNS is set in interactive bash shells.  It probably isn't set
1109 # in this shell, so let's set it if it isn't.
1110 : ${COLUMNS:=$(stty size 2>/dev/null | sed -e 's@.* @@')}
1111 : ${COLUMNS:=80}
1112 export COLUMNS
1113
1114 # Print text assuming it starts after other text in $startcol and
1115 # needs to wrap before $COLUMNS - 2.  Subsequent lines start at $startcol.
1116 # Long "words" will extend past $COLUMNS - 2.
1117 fill_text() {
1118     local startcol="$1"
1119     local text="$2"
1120
1121     local width=$(($COLUMNS - 2 - $startcol))
1122     [ $width -lt 0 ] && width=$((78 - $startcol))
1123
1124     local out=""
1125
1126     local padding
1127     if [ $startcol -gt 0 ] ; then
1128         padding=$(printf "\n%${startcol}s" " ")
1129     else
1130         padding="
1131 "
1132     fi
1133
1134     while [ -n "$text" ] ; do
1135         local orig="$text"
1136
1137         # If we already have output then arrange padding on the next line.
1138         [ -n "$out" ] && out="${out}${padding}"
1139
1140         # Break the text at $width.
1141         out="${out}${text:0:${width}}"
1142         text="${text:${width}}"
1143
1144         # If we have left over text then the line break may be ugly,
1145         # so let's check and try to break it on a space.
1146         if [ -n "$text" ] ; then
1147             # The 'x's stop us producing a special character like '(',
1148             # ')' or '!'.  Yuck - there must be a better way.
1149             if [ "x${text:0:1}" != "x " -a "x${text: -1:1}" != "x " ] ; then
1150                 # We didn't break on a space.  Arrange for the
1151                 # beginning of the broken "word" to appear on the next
1152                 # line but not if it will make us loop infinitely.
1153                 if [ "${orig}" != "${out##* }${text}" ] ; then
1154                     text="${out##* }${text}"
1155                     out="${out% *}"
1156                 else
1157                     # Hmmm, doing that would make us loop, so add the
1158                     # rest of the word from the remainder of the text
1159                     # to this line and let it extend past $COLUMNS - 2.
1160                     out="${out}${text%% *}"
1161                     if [ "${text# *}" != "$text" ] ; then
1162                         # Remember the text after the next space for next time.
1163                         text="${text# *}"
1164                     else
1165                         # No text after next space.
1166                         text=""
1167                     fi
1168                 fi
1169             else
1170                 # We broke on a space.  If it will be at the beginning
1171                 # of the next line then remove it.
1172                 text="${text# }"
1173             fi
1174         fi
1175     done
1176
1177     echo "$out"
1178 }
1179
1180 # Display usage text, trying these approaches in order.
1181 # 1. See if it all fits on one line before $COLUMNS - 2.
1182 # 2. See if splitting before the default value and indenting it
1183 #    to $startcol means that nothing passes $COLUMNS - 2.
1184 # 3. Treat the message and default value as a string and just us fill_text()
1185 #    to format it. 
1186 usage_display_text () {
1187     local startcol="$1"
1188     local desc="$2"
1189     local default="$3"
1190     
1191     local width=$(($COLUMNS - 2 - $startcol))
1192     [ $width -lt 0 ] && width=$((78 - $startcol))
1193
1194     default="(default \"$default\")"
1195
1196     if [ $((${#desc} + 1 + ${#default})) -le $width ] ; then
1197         echo "${desc} ${default}"
1198     else
1199         local padding=$(printf "%${startcol}s" " ")
1200
1201         if [ ${#desc} -lt $width -a ${#default} -lt $width ] ; then
1202             echo "$desc"
1203             echo "${padding}${default}"
1204         else
1205             fill_text $startcol "${desc} ${default}"
1206         fi
1207     fi
1208 }
1209
1210 # Display usage information for long config options.
1211 usage_smart_display () {( # sub-shell for local declaration of defconf()
1212         local startcol=33
1213
1214         defconf() {
1215             local local longopt=$(echo "$1" | tr 'A-Z_' 'a-z-')
1216
1217             printf "     --%-25s " "${longopt}=${3}"
1218
1219             usage_display_text $startcol "$4" "$2"
1220         }
1221
1222         "$@"
1223 )}
1224
1225
1226 # Display usage information for long config options.
1227 usage_config_options (){
1228     usage_smart_display load_config
1229 }
1230
1231 actions_init ()
1232 {
1233     actions=""
1234 }
1235
1236 actions_add ()
1237 {
1238     actions="${actions}${actions:+ }$*"
1239 }
1240
1241 actions_run ()
1242 {
1243     [ -n "$actions" ] || usage
1244
1245     local a
1246     for a in $actions ; do
1247         $a
1248     done
1249 }
1250
1251 ######################################################################
1252
1253 post_config_hooks=
1254
1255 ######################################################################
1256
1257 load_config
1258
1259 ############################
1260 # parse command line options
1261 long_opts=$(getopt_config_options)
1262 getopt_output=$(getopt -n autocluster -o "c:e:E:xh" -l help,dump -l "$long_opts" -- "$@")
1263 [ $? != 0 ] && usage
1264
1265 use_default_config=true
1266
1267 # We do 2 passes of the options.  The first time we just handle usage
1268 # and check whether -c is being used.
1269 eval set -- "$getopt_output"
1270 while true ; do
1271     case "$1" in
1272         -c) shift 2 ; use_default_config=false ;;
1273         -e) shift 2 ;;
1274         -E) shift 2 ;;
1275         --) shift ; break ;;
1276         --dump|-x) shift ;;
1277         -h|--help) usage ;; # Usage should be shown here for real defaults.
1278         --*) shift 2 ;; # Assume other long opts are valid and take an arg.
1279         *) usage ;; # shouldn't happen, so this is reasonable.
1280     esac
1281 done
1282
1283 config="./config"
1284 $use_default_config && [ -r "$config" ] && . "$config"
1285
1286 eval set -- "$getopt_output"
1287
1288 while true ; do
1289     case "$1" in
1290         -c)
1291             b=$(basename $2)
1292             # force at least ./local_file to avoid accidental file
1293             # from $PATH
1294             . "$(dirname $2)/${b}"
1295             # If $CLUSTER is unset then try to base it on the filename
1296             if [ ! -n "$CLUSTER" ] ; then
1297                 case "$b" in
1298                     *.autocluster)
1299                         CLUSTER="${b%.autocluster}"
1300                 esac
1301             fi
1302             shift 2
1303             ;;
1304         -e) no_sanity=1 ; run_hooks post_config_hooks ; eval "$2" ; exit ;;
1305         -E) eval "$2" ; shift 2 ;;
1306         -x) set -x; shift ;;
1307         --dump) no_sanity=1 ; run_hooks post_config_hooks ; dump_config ;;
1308         --) shift ; break ;;
1309         -h|--help) usage ;; # Redundant.
1310         --*)
1311             # Putting --opt1|opt2|... into a variable and having case
1312             # match against it as a pattern doesn't work.  The | is
1313             # part of shell syntax, so we need to do this.  Look away
1314             # now to stop your eyes from bleeding! :-)
1315             x=",${long_opts}" # Now each option is surrounded by , and :
1316             if [ "$x" != "${x#*,${1#--}:}" ] ; then
1317                 # Our option, $1, surrounded by , and : was in $x, so is legal.
1318                 setconf_longopt "$1" "$2"; shift 2
1319             else
1320                 usage
1321             fi
1322             ;;
1323         *) usage ;; # shouldn't happen, so this is reasonable.
1324     esac
1325 done
1326
1327 run_hooks post_config_hooks 
1328
1329 # catch errors
1330 set -e
1331 set -E
1332 trap 'es=$?; 
1333       echo ERROR: failed in function \"${FUNCNAME}\" at line ${LINENO} of ${BASH_SOURCE[0]} with code $es; 
1334       exit $es' ERR
1335
1336 # check for needed programs 
1337 check_command expect
1338
1339 [ $# -lt 1 ] && usage
1340
1341 t="$1"
1342 shift
1343
1344 case "$t" in
1345     base)
1346         actions_init
1347         for t in "$@" ; do
1348             case "$t" in
1349                 create|boot) actions_add "base_${t}" ;;
1350                 *) usage ;;
1351             esac
1352         done
1353         actions_run
1354         ;;
1355
1356     cluster)
1357         actions_init
1358         for t in "$@" ; do
1359             case "$t" in
1360                 destroy|create|update_hosts|boot)
1361                     actions_add "cluster_${t}" ;;
1362                 *) usage ;;
1363             esac
1364         done
1365         actions_run
1366         ;;
1367
1368     create)
1369         t="$1"
1370         shift
1371         case "$t" in
1372             base)
1373                 [ $# != 0 ] && usage
1374                 base_create
1375                 ;;
1376             cluster)
1377                 [ $# != 1 ] && usage
1378                 cluster_create "$1"
1379                 ;;
1380             node)
1381                 [ $# != 2 ] && usage
1382                 create_one_node "$1" "$2"
1383                 ;;
1384             *)
1385                 usage;
1386                 ;;
1387         esac
1388         ;;
1389     mount)
1390         [ $# != 1 ] && usage
1391         diskimage mount "$1"
1392         ;;
1393     unmount|umount)
1394         [ $# != 0 ] && usage
1395         diskimage unmount
1396         ;;
1397     bootbase)
1398         base_boot;
1399         ;;
1400     *)
1401         usage;
1402         ;;
1403 esac